section \<open>Insertion Sort and Multisets\<close>

theory Insertion_Sort_Multiset
imports Main
begin

subsection \<open>Definition of insertion sort as before\<close>

fun ins :: "'a::ord \<Rightarrow> 'a list \<Rightarrow> 'a list"
where
  "ins x [] = [x]"
| "ins x (y # ys) = (if x \<le> y then x # y # ys else y # ins x ys)"

definition isort :: "'a::ord list \<Rightarrow> 'a list"
  where "isort xs = foldr ins xs []"


subsection \<open>Exercise: characterization of permuted result via multisets\<close>

text \<open>
  \<triangleright> Use the concept of multisets to express the desired property of
    permutation of results.

  Hint: This requires import of "~~/src/HOL/Library/Multiset" from
  the Supplemental Isabelle/HOL Library.

  \<triangleright> Prove the main theorem by re-using lemmas from the old version
    without multisets.

  Hint: The 'abbreviation' command helps to adjust abstract syntax,
  without any logical impact.
\<close>

end
